/**********************************************************************
 * This file is part of FMR (Fast Machine Reassignment)               
 *                                                                   
 * ROADEF/EURO Challenge 2012: Machine Reassignment                 
 * http://challenge.roadef.org/2012/en/				   
 * Team S26
 *     
 * Copyright (C) 2011-12 Laboratoire d'Informatique de Paris Nord 
 * UMR CNRS 7030 
 * Institut Galilée - Université Paris-Nord
 * 99, avenue Jean-Baptiste Clément 
 * 93430 Villetaneuse  
 *        
 * FMR is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *  
 * FMR is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *  
 * You should have received a copy of the GNU General Public License
 * along with FMR; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 **********************************************************************/
#ifndef fmr_exploRecuit_b
#define fmr_exploRecuit_b

#include "fmr.h"
#include "stdlib.h"

long explo_recuit_b( const placement_t const * , placement_t* , struct drand48_data * rand_buf ) ;
long explo_recuit_best_loop_b( const placement_t const * , struct drand48_data * rand_buf ) ;
/*
 * passe de recuit
 */
typedef struct {
    double t0;                  /// heure du début du recuit
    double t1;                  /// heure de fin
    double delta_t;
    double T0;                  /// température du début
    double T1;                  /// température finale
    double delta_T;
    double t;                   /// heure actuelle
    double T;                   /// température actuelle
} temperature_t;


long
recuit_b (const placement_t const *initial, placement_t * courante,
          temperature_t s, struct drand48_data *rand_buf);

#endif
