/**********************************************************************
 * This file is part of FMR (Fast Machine Reassignment)               
 *                                                                   
 * ROADEF/EURO Challenge 2012: Machine Reassignment                 
 * http://challenge.roadef.org/2012/en/				   
 * Team S26
 *     
 * Copyright (C) 2011-12 Laboratoire d'Informatique de Paris Nord 
 * UMR CNRS 7030 
 * Institut Galilée - Université Paris-Nord
 * 99, avenue Jean-Baptiste Clément 
 * 93430 Villetaneuse  
 *        
 * FMR is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *  
 * FMR is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *  
 * You should have received a copy of the GNU General Public License
 * along with FMR; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 **********************************************************************/
#ifndef _fmr_stats_h_
#define _fmr_stats_h_

#include "fmr.h"

/** statistiques globales */

struct statistiques {
    double moyenne;       /* Moyenne de charge */
    double stddev;        /* Ecart type des charges */
    double moyenne_safe;  /* Moyenne de l'ecart avec la safe capacity */
    double stddev_safe;   /* Ecart-type de l'ecart avec la safe capacity */
    double min;           /* Charge min */
    double max;           /* Charge min */
};

typedef struct statistiques stats_t;





void check_depassements_capa(placement_t *);

stats_t* calcul_stats_placement( placement_t );

int afficher_stats( stats_t* );


/** statistiques sur les contraintes bloquantes lors d'un mouvement */

struct contraintes_bloquantes {
    int64 nb_mvt ; // nombre de mouvements testés
    int64 nb_mvt_interdit ; // nombre de mouvements testés interdits
    int64 nb_bloquant_capacity ;
    int64 nb_bloquant_service_present ; // contraintes "conflicts"
    int64 nb_bloquant_dependancy ;
    int64 nb_bloquant_spread ;
};

typedef struct contraintes_bloquantes stats_blocking_t;






#endif
